﻿infrastructureModule
    .controller('OrganizationManageController', ['$scope', '$location', '$log', 'orgHKService', '$interval', 'uiGridTreeViewConstants', 'uiGridConstants', 'SweetAlert', '$translate', '$timeout', 'apiInterceptor', '$q', 'loginContext', '$cookies', 'Upload','FileSaver',
        function ($scope, $location, $log, orgHKService, $interval, uiGridTreeViewConstants, uiGridConstants, SweetAlert, $translate, $timeout, apiInterceptor, $q, loginContext, $cookies, Upload,FileSaver) {
            'use strict';

            $scope.expanded = false;
            $scope.showOrgs = true;
            $scope.showSingle = false;
            $scope.selectNodeCount = 0;
            $scope.startDate = new Date(2019, 0, 1);
            $scope.endDate = new Date(2019, 11, 31);

            $scope.showTaxRegInfoContent = true;
            $scope.showExtraRegInfoContent = true;

            $scope.showTaxRule = false;
            $scope.showReturnRateInfo = false;
            $scope.showAccountingRateInfo = false;
            $scope.showApprovedLevyInfo = false;
            $scope.showTaxOfficerInfo = false;
            $scope.showInvoiceInfo = false;
            $scope.showTaxpayerQualification = false;
            $scope.showEmployee = false;
            $scope.isInternational = false;
            $scope.isNotHundred = false;
            $scope.editOrgExtraModel = {};

            var translate = {
                Enabled: $translate.instant('Actived'),  //已启用
                Disabled: $translate.instant('Disabled')//已停用
            };

            //jack
            $scope.getBottomHeight = function () {

                if ($scope.isLoadComplete) {
                    var y = $(".company-detail").height();
                    var parent = $('.org-right-container').height();
                    return {height: parent - y + 'px'};
                }

                return {};
            };

            $scope.visiableTaxRegInfo = function () {
                if ($scope.showTaxRegInfoContent) {
                    $scope.showTaxRegInfoContent = false;
                } else {
                    $scope.showTaxRegInfoContent = true;
                }
            };

            $scope.visiableTaxExtraInfo = function () {
                if ($scope.showExtraRegInfoContent) {
                    $scope.showExtraRegInfoContent = false;
                } else {
                    $scope.showExtraRegInfoContent = true;
                }
            };

            //初始化ack-pagination
            $scope.pagingOptions = {
                pageIndex: 1, //当前页码
                totalItems: 0, //总数据
                totalPages: 10, //总页数
                maxSize: 5, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
                pageSizeString: constant.page.pageSizeArrary[3].toString(),
                firstPage: $translate.instant('PagingFirstPage'),
                previousPage: $translate.instant('PagingPreviousPage'),
                nextPage: $translate.instant('PagingNextPage'),
                lastPage: $translate.instant('PagingLastPage')
            };

            // 机构树
            var tree;

            // 是佛启用禁用Map
            var isActiveMap = {
                false: 'Enable',
                true: 'Disable'
            };

            var dataType = {
                isPrefixNumber: function (value) {
                    var reg = /^\d+/;
                    if (reg.test(value)) {
                        return true;
                    } else {
                        return false;
                    }
                },
                isPrefixChar: function (value) {
                    var reg = /^[a-zA-Z]+/;
                    if (reg.test(value)) {
                        return true;
                    } else {
                        return false;
                    }
                },
                isPrefixNumberOrChar: function (value) {
                    if (dataType.isPrefixNumber(value)) {
                        return true;
                    }

                    if (dataType.isPrefixChar(value)) {
                        return true;
                    }

                    return false;
                }
            };

            var initPagingControl = function (totalItemsCount) {
                $scope.pagingOptions.totalItems = totalItemsCount;
            };

            // 初始化函数
            var initOrg = function () {
                loadorgTree();
            };

            var getOrgList = function () {
                orgHKService.getOrgInfoList().success(function (data) {
                    if (data) {
                        initPagingControl(data.length);
                        $scope.DataGridSource = data;

                        // $scope.shareholderDatasource  = data.shareholders;
                        // $scope.directorDatasource = data.directors;

                        $scope.oldData = angular.copy(data);
                        $scope.setGridHeight();
                    }
                });
            };

            // 保存启用、启用的操作结果
            $scope.updateIsActive = function () {
                $scope.isCanOrganizationIsActiveBtn = false;
                var isActive = !$scope.selectCompany.isActive;
                if (isActive) {
                    orgHKService.enableOrgs($scope.selectCompany.id).success(function () {
                        SweetAlert.success($translate.instant('EnableUserSuccess'));

                        $scope.selectCompany.isActive = !$scope.selectCompany.isActive;
                        $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                        $log.debug('enabled success!');
                        $scope.organizationId = $scope.selectCompany.id;
                        loadorgTree();
                    })['finally'](function () {
                        $scope.isCanOrganizationIsActiveBtn = true;

                    });
                } else {
                    var list = [];
                    list.push($scope.selectCompany.id);
                    orgHKService.disableOrgs(list).success(function () {
                        SweetAlert.success($translate.instant('DisableUserSuccess'));

                        $scope.selectCompany.isActive = !$scope.selectCompany.isActive;
                        $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                        $log.debug('disabled orgs success!');
                        $scope.organizationId = $scope.selectCompany.id;
                        loadorgTree();
                    })['finally'](function () {
                        $scope.isCanOrganizationIsActiveBtn = true;
                    });
                }
                // generalSelectCompanyText();
            };

            // 进入高级配置编辑状态
            $scope.editAdvancedConfigurationStatus = function () {
                $scope.selectCompany.isUpdate = true;
                setEnterpriseOrgRowList($scope.selectCompany);

                if ($scope.selectCompany.organizationServiceTemplateGroupList && $scope.selectCompany.organizationServiceTemplateGroupList.length > 0) {

                    $scope.selectCompany.organizationServiceTemplateGroupList.forEach(function (row) {

                        row.templateGroupList = _.find($scope.serviceList, function (num) {
                            return num.id === row.serviceTypeID
                        }).templateGroupList;
                    });
                }

            };

            // 保存高级配置修改
            $scope.saveAdvancedConfiguration = function () {

                if (checkEnterpriseSetOrg() || checkTemplateList() || checkServiceTypeList()) {
                    return;
                }

                var branch = {
                    data: {
                        id: $scope.selectCompany.id
                    }
                };

                orgHKService.updateOrg($scope.selectCompany).success(function (data) {
                    if (data && !data.result) {
                        SweetAlert.warning($translate.instant(data.resultMsg));
                        return;
                    }

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    $scope.selectOrganization(branch);
                });
            };

            // 取消高级配置修改
            $scope.cancelAdvancedConfiguration = function () {
                $scope.selectCompany.enterpriseAccountSetOrgList = angular.copy($scope.backups.enterpriseAccountSetOrgList);
                $scope.selectCompany.organizationServiceTemplateGroupList = angular.copy($scope.backups.organizationServiceTemplateGroupList);
                $scope.selectCompany.isUpdate = false;
            };

            // 关于日志部分
            $scope.showOperateLogPop = function () {
                $scope.isShowLog = true;
            };

            // 添加机构
            $scope.addOrg = function () {
                $scope.orgOperateType = constant.Operation.Add;
                $scope.isAdd = true;
                $scope.selectedOrg = null;
                $scope.showEditModal = true;
            };

            // 编辑机构
            $scope.updateOrg = function () {
                $scope.isAdd = false;
                $scope.orgOperateType = constant.Operation.Edit;
                $scope.selectedOrg = $scope.selectCompany;
                $scope.showEditModal = true;
            };

            // 取消编辑机构其他信息
            // TODO 将这个方法添加到切换功能里
            $scope.updateOrgExtraCancel = function () {
                $scope.selectCompanyExtra = $scope.comExtraOldData;
                $scope.editOrgExtraModel = $scope.editOldData;
                generalSelectCompanyExtraText();
                cancelWebChange();
            };

            // 提交修改的机构其他信息
            // $scope.updateOrgExtraSubmit = function () {
            //     SweetAlert.swal({
            //             title: $translate.instant('ComfirmUpdate'),
            //             text: $translate.instant('UpdateOrgExtraInfoTips'),
            //             type: "warning",
            //             showCancelButton: true,
            //             confirmButtonColor: "#DD6B55",
            //             confirmButtonText: $translate.instant('Confirm'),
            //             cancelButtonText: $translate.instant('Cancel'),
            //             closeOnConfirm: false,
            //             closeOnCancel: true
            //         },
            //         function (isConfirm) {
            //             if (isConfirm) {
            //                 // 选中
            //                 updateOrgExtraInfo($scope.selectCompany.id);
            //             }
            //         });
            // };
            //
            // var updateOrgExtraInfo = function (id) {
            //     var editData = $scope.editOrgExtraModel;
            //     editData.organizationId = id;
            //     orgHKService.updateOrgExtraInfoByOrgId(editData).success(function (res) {
            //         if (res && !res.result) {
            //             SweetAlert.warning($translate.instant(res.resultMsg));
            //             return;
            //         }
            //         if (res) {
            //             orgHKService.getSingleOrgExtra(id).success(function (data) {
            //                 if (data == null) {
            //                     SweetAlert.warning($translate.instant(data.resultMsg));
            //                     return;
            //                 }
            //                 $scope.editOrgExtraModel = angular.copy(data);
            //                 $scope.selectCompanyExtra = data;
            //                 generalSelectCompanyExtraText();
            //                 cancelWebChange();
            //                 SweetAlert.success($translate.instant('OrganizationExtraInfoEditSuccess'));
            //             });
            //         }
            //     });
            // };

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('isOrgUpdate', function (newValue, oldValue) {
                if (newValue) {
                    if ($scope.selectCompany && !$scope.isAdd) {
                        $scope.organizationId = $scope.selectCompany.id;
                    } else {
                        $scope.organizationId = null;
                    }
                    initOrg();
                    $scope.isOrgUpdate = false;
                }
            });

            // 选中机构
            $scope.selectOrganization = function (branch) {
                var org = branch.data;
                $scope.output = "You selected: " + org.id;

                var suborgList = getSubOrgList(branch);
                $scope.selectedOrgID = org.id;
                // 选中事件
                orgHKService.getSingleOrg(org.id).success(function (data) {
                    if ($scope.selectNodeCount > 1) {
                        $scope.showOrgs = false;
                        $scope.showSingle = true;
                    }
                    $scope.selectNodeCount++;
                    $scope.selectCompany = data;
                    $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);

                    $scope.directorDatasource = data.directors;
                    $scope.shareholderDatasource = data.shareholders;
                    $scope.attachmentDatasource = data.attachments;

                    $scope.selectCompany.suborgList = suborgList;
                    $scope.backups = {};
                    $scope.backups.enterpriseAccountSetOrgList = angular.copy($scope.selectCompany.enterpriseAccountSetOrgList);
                    $scope.backups.organizationServiceTemplateGroupList = angular.copy($scope.selectCompany.organizationServiceTemplateGroupList);
                });
            };

            $scope.resources = {
                EffectiveDateRequired: $translate.instant('EffectiveDateRequired'),
                ExpiredDateRequired: $translate.instant('ExpiredDateRequired'),
                EffectiveDateAreaProblem: $translate.instant('EffectiveDateAreaProblem'),
                OrganizationMsgTemplateRequired: $translate.instant('OrganizationMsgTemplateRequired'),
                OrganizationMsgProjectIndustryRequired: $translate.instant('OrganizationMsgProjectIndustryRequired'),
                ServiceExists: $translate.instant('ServiceExists'),
                DateMonthFormatError: $translate.instant('DateMonthFormatError')
            };

            // 验证开始时间
            $scope.checkStartDate = function (row) {


                // if (!row.effectiveDateStr) {
                //     row.startDateError = $scope.resources.EffectiveDateRequired;
                // } else {
                //     row.startDateError = null;
                // }

                if (row.effectiveDateStr && !window.PWC.checkMonth(row.effectiveDateStr)) {
                    row.startDateError = $scope.resources.DateMonthFormatError;
                    return;
                } else {
                    row.startDateError = null;
                }

                if (!row.enterpriseAccountSetID && !row.effectiveDateStr && !row.expiredDateStr) {
                    row.startDateError = null;
                    return;
                }

                if (row.effectiveDateStr && row.expiredDateStr) {

                    if (!validateDate(row.effectiveDateStr, row.expiredDateStr)) {
                        row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                    } else {
                        row.startDateError = null;
                    }
                }
            };

            // 验证结束时间
            $scope.checkEndDate = function (row) {

                //结束时间可为空，默认9999-12
                // if (!row.expiredDateStr) {
                //     row.endDateError = $scope.resources.ExpiredDateRequired;
                // } else {
                //     row.endDateError = null;
                // }

                if (row.expiredDateStr && !window.PWC.checkMonth(row.expiredDateStr)) {
                    row.endDateError = $scope.resources.DateMonthFormatError;
                    return;
                } else {
                    row.endDateError = null;
                }

                if (!row.enterpriseAccountSetID && !row.effectiveDateStr && !row.expiredDateStr) {
                    row.endDateError = null;
                    return;
                }

                if (row.effectiveDateStr && row.expiredDateStr) {
                    if (!validateDate(row.effectiveDateStr, row.expiredDateStr)) {
                        row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                    } else {
                        row.startDateError = null;
                    }
                }
            };

            // 加载机构树
            $scope.my_tree = tree = {};

            var loadorgTree = function () {

                $scope.orgList = [];
                $scope.doing_async = true;

                $scope.showOrgTree = false;

                orgHKService.getOrgListToJson(1).success(function (data) {
                    $scope.orgList = data;
                    $log.debug(data);
                    // 设置默认选中机构
                    if (data && data.length > 0) {

                        var selectOrg = data[0];
                        if ($scope.organizationId) {
                            selectOrg = findBranch($scope.organizationId, $scope.orgList);
                            if (!selectOrg) {
                                selectOrg = data[0];
                            }
                        }

                        $scope.selectOrganization(selectOrg);
                    }

                    $scope.doing_async = false;

                    return $timeout(function () {
                        $scope.my_tree.expand_level_function();
                        $scope.my_tree.select_branch(selectOrg);
                        $scope.showOrgTree = true;
                    }, 200);

                    return tree.expand_level_function();

                }).error(function (data) {

                    $log.debug(JSON.stringify(data));
                });
            };

            // 查找选中的分支
            var findBranch = function (orgid, orgTree) {
                if (orgTree && orgTree.length > 0) {

                    for (var i = 0; i < orgTree.length; i++) {
                        var row = orgTree[i];

                        // 查看当前节点
                        if (row.data.id === orgid) {
                            target = row;
                            return target;
                        }

                        // 查看子节点
                        var target = findBranch(orgid, row.children);
                        if (target) {
                            return target;
                        }
                    }

                    return null;
                } else {
                    return null;
                }
            };

            // 验证是否为时间段
            var validateDate = function (from, to) {
                var fromDate = new Date(from + '-01');
                var toDate = new Date(to + '-01');
                toDate.setMonth(toDate.getMonth() + 1);
                toDate.setDate(toDate.getDate() - 1);

                if (fromDate <= toDate) {
                    return true;
                } else {
                    return false;
                }
            };

            // 获取当前机构下的子机构
            var getSubOrgList = function (branch) {

                var orgList = [];

                if (branch.children && branch.children.length > 0) {
                    branch.children.forEach(function (row) {
                        orgList.push(row.data);
                        var tempList = getSubOrgList(row);
                        if (tempList && tempList.length > 0) {
                            orgList = _.union(orgList, tempList);
                        }
                    });
                }

                return orgList;
            };

            $scope.permissionPopover = {
                //content: $scope.permissionList,
                templateUrl: 'permissionPopoverTemplate.html',
                title: $translate.instant('TPermission')
            };

            $scope.getGridHeight = function () {
                return {height: $(".dx-viewport").height() + "px"};
            };

            // 初始化参数信息
            var initParams = function () {
                $scope.showRowLines = true;
                $scope.orgList = [];
                $scope.checkedOrgsSet = {};
                $scope.set = [];
                $scope.maxTitleLength = 10;
                $scope.maxValueLength = 20;
                $scope.selectCompany = {};
                $scope.showAttributeDimensionID = 'orgmanage';
                $scope.searchText = '';
                $scope.isCanOrganizationIsActiveBtn = true;
                $scope.currentNavItem = 'page1';
                $scope.userRoleList = "[]";

                $scope.taxReturnBusinessTypeList = constant.TaxReturnBusinessTypeList;
                $scope.trueFalse = constant.trueFalse;
                $scope.regFinancialAccountingTypeList = constant.RegFinancialAccountingTypeList;
                $scope.nationalEconomicIndustryList = constant.NationalEconomicIndustryList;
                $scope.applicableAccountingRuleList = constant.ApplicableAccountingRuleList;
                $scope.regStatusList = constant.RegStatusList;
                $scope.lowValueConsumablesAmortizationMethodList = constant.LowValueConsumablesAmortizationMethodList;
                $scope.depreciationMethodList = constant.DepreciationMethodList;
                $scope.taxCreditRatingList = constant.TaxCreditRatingList;
                $scope.architectureTypeList = constant.ArchitectureTypeList;
            };

            var loadDatagrid = function () {
                $scope.orgUserGridOptionsA = {
                    bindingOptions: {
                        dataSource: 'DataGridSource'
                    },
                    height: 770,
                    showBorders: true,
                    paging: {
                        pageSize: constant.page.logPageSize
                    },
                    pager: {
                        showPageSizeSelector: true,
                        allowedPageSizes: constant.page.pageSizeArrary,
                        showInfo: true
                    },
                    // export: {
                    //     enabled: false,
                    //     fileName: "机构信息列表"
                    // },
                    // columnChooser: {
                    //     enabled: true
                    // },
                    keyExpr: "name",
                    columns: [
                        {
                            dataField: "name",
                            caption: $translate.instant('OrganizationName'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    $('<a class="hyper-link">' + options.value + '</a>')
                                        .attr('href', 'javascript:void(0)')
                                        .on('click', function () {
                                            gotoOrg(options.row.data);
                                        })
                                        .appendTo(container);
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "code",
                            allowHeaderFiltering: false,
                            caption: $translate.instant('OrganizationCode')
                        },
                        {
                            dataField: "legalForm",
                            allowHeaderFiltering: true,
                            caption: $translate.instant('legalForm')
                        },
                        {
                            dataField: "entityLevel",
                            caption: $translate.instant('entityLevel')
                        },
                        {
                            dataField: "businessLicense",
                            caption: $translate.instant('businessLicense'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "dateOfIncorporation",
                            caption: $translate.instant('dateOfIncorporation'),
                            allowHeaderFiltering: false,
                            dataType: "date",
                            format: "yyyy-MM-dd"
                        },
                        {
                            dataField: "jurisdictionOfFormation",
                            caption: $translate.instant('jurisdictionOfFormation'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "financialYearEnd",
                            caption: $translate.instant('financialYearEnd'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "isActive",
                            caption: $translate.instant('EnableStatus'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    if (options.data.isActive) {
                                        $('<span>').text(translate.Enabled).appendTo(container);
                                    } else {
                                        $('<span style="color:gray">').text(translate.Disabled).appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        }
                    ],
                    // masterDetail: {
                    //     enabled: false,
                    //     template: "detail"
                    // },
                    onContentReady: function (e) {
                        $scope.orgUserGridInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    allowColumnReordering: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll')
                        }
                    }
                };
            };

            var gotoOrg = function (org) {
                $scope.showOrgs = false;
                console.log(org);
                $scope.selectCompany = org;
                $scope.shareholderDatasource = org.shareholders;
                $scope.directorDatasource = org.directors;
                $scope.attachmentDatasource = org.attachments;
                $scope.showSingle = true;
            };

            $scope.showAll = function () {
                $scope.showOrgs = true;
                getOrgList();
                $scope.showSingle = false;
                $scope.selectCompany = {};
            };

            var token = $('input[name="__RequestVerificationToken"]').val();
            var webHost = apiInterceptor.webApiHostUrl;
            var apiTokenObj = $cookies.getObject('AtmsApiToken');

            $scope.uploadFiles = function (files, errFiles) {
                $scope.f = files;
                $scope.showError = false;
                $scope.errFile = errFiles && errFiles[0];
                if (files && files.length) {
                    var fileNames = [];
                    angular.forEach($scope.f, function (file) {
                        fileNames.push(file.name);
                    });
                    $scope.filePath = fileNames.toString();//$scope.f[0].name;
                    // if (!checkUploadFiles($scope.f)) {
                    //     return false;
                    // }
                    var resumable = true;
                    $scope.chunkSize = "10MB";
                    Upload.upload({
                        url: webHost + '/orgHK/upload?entityId=' + $scope.selectCompany.id,
                        data: {
                            file: files
                        },
                        arrayKey: '',
                        resumeChunkSize: resumable ? $scope.chunkSize : null,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiTokenObj.token_type + ' ' + apiTokenObj.access_token,
                            __RequestVerificationToken: token,
                            withCredentials: true
                        },
                        withCredentials: true
                    }).then(function (response) {
                        console.log(response);
                        var ret = response.data;
                        if (ret.result) {
                            //todo: add the result data to exist attachments files list
                            $scope.attachmentDatasource = $scope.attachmentDatasource.concat(ret.data);
                        }
                        else {
                            if (ret.resultMsg && ret.resultMsg.length > 0) {
                                swal({
                                    title: $translate.instant('FailureTitle'),
                                    text: $translate.instant('UploadFileFail') + ret.resultMsg,
                                    type: "error",
                                    confirmButtonText: $translate.instant('Confirm')
                                });
                            }
                        }
                    }, function (response) {
                        console.log('import error: ' + response.status);
                        if (response.status > 0) {
                            $log.debug('upload attach file error:');
                            $log.debug(response.status + ': ' + response.data);
                        }
                    }, function (evt) {
                        $scope.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                    });
                }
                else {
                }
            };

            function checkUploadFiles(files) {
                var result = true;
                for (var i = 0; i < files.length; i++) {
                    var item = files[i];
                    var fileName = item.name;
                    var fileExtension = fileName.substr(fileName.lastIndexOf(".") + 1, fileName.length - fileName.lastIndexOf(".")).toLowerCase();
                    if (fileExtension !== ValidFileExtension.CSV
                        && fileExtension !== ValidFileExtension.XLS
                        && fileExtension !== ValidFileExtension.XLSX) {
                        swal({
                            title: $translate.instant('WarningTitle'),
                            text: $translate.instant('ErpUploadFileExtensionCheck'),
                            type: "warning",
                            confirmButtonText: $translate.instant('Confirm')
                        });
                        result = false;
                    }

                    if (fileName.length >= 30) {
                        SweetAlert.warning($translate.instant('FileNameTooLong'));
                        result = false;
                    }
                }

                return result;
            }

            $scope.exportOrgs = function () {

            };

            $scope.refreshOrg = function () {
                getOrgList();
            };

            $scope.addEquity = function () {
                $scope.isShowShareholderModal2 = true;
            };

            $scope.addDirector = function () {
                $scope.isShowDirectorModal2 = true;
            };

            $scope.directorGridOptions = {
                bindingOptions: {
                    dataSource: 'directorDatasource'
                },
                height: 160,
                showBorders: true,
                paging: {
                    pageSize: constant.page.logPageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                },
                keyExpr: "id",
                columns: [
                    {
                        dataField: "directorName",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('directorName')
                    },
                    {
                        dataField: "residency",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('residency'),
                    },
                    {
                        dataField: "dateOfAppointment",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('dateOfAppointment'),
                        dataType: "date",
                        format: "yyyy-MM-dd"
                    },
                    {
                        dataField: "dateOfResignation",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('dateOfResignation'),
                        dataType: "date",
                        format: "yyyy-MM-dd"
                    },
                    {
                        dataField: "executive",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('executive'),
                    },
                    {
                        dataField: "otherRoles",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('otherRoles'),
                    },
                    {
                        dataField: "id",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('operation'),
                        cellTemplate: function (container, options) {
                            try {
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "editDirector2(\'' + options.data.id + '\')"><i class="material-icons middle" style="vertical-align: text-bottom">modify</i>edit</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "deleteDirector2(\'' + options.data.id + '\')"><i class="material-icons middle" style="vertical-align: text-bottom">delete</i>delete</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                            }
                            catch (e) {
                                $log.error(e);
                            }
                        }
                    }
                ],
                onContentReady: function (e) {
                    $scope.directorGridInstance = e.component;
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                allowColumnReordering: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width: 518,
                    visible: false
                },
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };

            $scope.equityGridOptions = {
                bindingOptions: {
                    dataSource: 'shareholderDatasource'
                },
                height: 150,
                showBorders: true,
                paging: {
                    pageSize: constant.page.logPageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                },
                keyExpr: "id",
                columns: [
                    {
                        dataField: "investmentEntity",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('investmentEntity'),
                        calculateDisplayValue: function (data) {
                            // var importType1 = _.find(constant.importTypeList, function (item) {
                            //     return item.value == data.importType;
                            // });
                            // if (importType1) {
                            //     return importType1.name;
                            // } else {
                            //     return '未知';
                            // }
                        }
                    },
                    {
                        dataField: "ownershipForm",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('ownershipForm'),
                    },
                    {
                        dataField: "commonOrPreferred",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('commonOrPreferred'),
                        calculateDisplayValue: function (data) {
                            // var importType1 = _.find(constant.importTypeList, function (item) {
                            //     return item.value == data.importType;
                            // });
                            // if (importType1) {
                            //     return importType1.name;
                            // } else {
                            //     return '未知';
                            // }
                        }
                    },
                    {
                        dataField: "classOfShares",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('classOfShares'),
                    },
                    {
                        dataField: "votingPercentage",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('votingPercentage'),
                    },
                    {
                        dataField: "id",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('operation'),
                        cellTemplate: function (container, options) {
                            try {
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "editShareholder2(\'' + options.data.id + '\')"><i class="material-icons middle" style="vertical-align: text-bottom">modify</i>edit</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "deleteShareholder2(\'' + options.data.id + '\')"><i class="material-icons middle" style="vertical-align: text-bottom">delete</i>delete</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                            }
                            catch (e) {
                                $log.error(e);
                            }
                        }
                    }
                ],
                onContentReady: function (e) {
                    $scope.shareholderGridInstance = e.component;
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                allowColumnReordering: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width: 518,
                    visible: false
                },
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };

            $scope.closeSharehoder2 = function () {
                $scope.isShowShareholderModal2 = false;
            };

            $scope.saveShareholder2 = function (shareholderEntity) {
                var shareholder = _.filter($scope.shareholderDatasource, function (item) {
                    return item.id === shareholderEntity.id;
                });

                if (shareholder && shareholder.length > 0) {
                    $scope.shareholderDatasource = _.without($scope.shareholderDatasource, shareholder[0]);
                }
                $scope.shareholderDatasource.push(shareholderEntity);

                orgHKService.updateShareholders($scope.shareholderDatasource);
            };

            window.editShareholder2 = function (id) {
                console.log("editShareholder    " + id);
                var shareholder = _.filter($scope.shareholderDatasource, function (item) {
                    return item.id === id;
                });

                if (shareholder && shareholder.length > 0) {
                    $scope.gModel.editShareholderModel = shareholder[0];
                    $scope.isShowShareholderModal2 = true;
                }
            };

            window.deleteShareholder2 = function (id) {
                console.log("deleteShareholder    " + id);
                var shareholder = _.filter($scope.shareholderDatasource, function (item) {
                    return item.id === id;
                });
                if (shareholder && shareholder.length > 0) {
                    $scope.shareholderDatasource = _.without($scope.shareholderDatasource, shareholder[0]);
                }
            };

            $scope.closeDirector2 = function () {
                $scope.isShowDirectorModal2 = false;
            };

            $scope.saveDirector2 = function (directorEntity) {
                var director = _.filter($scope.directorDatasource, function (item) {
                    return item.id === directorEntity.id;
                });

                if (director && director.length > 0) {
                    $scope.directorDatasource = _.without($scope.directorDatasource, director[0]);
                }
                $scope.directorDatasource.push(directorEntity);
                orgHKService.updateDirectors($scope.directorDatasource);
            };

            window.editDirector2 = function (id) {
                console.log("editDirector    " + id);
                var director = _.filter($scope.directorDatasource, function (item) {
                    return item.id === id;
                });

                if (director && director.length > 0) {
                    $scope.gModel.editDirectorModel = director[0];
                    $scope.isShowDirectorModal2 = true;
                }
            };

            window.deleteDirector2 = function (id) {
                console.log("deleteDirector    " + id);
                var director = _.filter($scope.directorDatasource, function (item) {
                    return item.id === id;
                });
                if (director && director.length > 0) {
                    $scope.directorDatasource = _.without($scope.directorDatasource, director[0]);
                }
            };

            $scope.attachmentGridOptions = {
                bindingOptions: {
                    dataSource: 'attachmentDatasource'
                },
                height: 160,
                showBorders: true,
                paging: {
                    pageSize: constant.page.logPageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                },
                keyExpr: "id",
                columns: [
                    {
                        dataField: "documentName",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('documentName')
                    },
                    {
                        dataField: "id",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('operation'),
                        cellTemplate: function (container, options) {
                            try {
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "downloadDocument(\'' + options.data.id + '\')"><i class="material-icons middle" style="vertical-align: text-bottom">modify</i>download</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "deleteDocument(\'' + options.data.id + '\')"><i class="material-icons middle" style="vertical-align: text-bottom">delete</i>delete</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                            }
                            catch (e) {
                                $log.error(e);
                            }
                        }
                    }
                ],
                onContentReady: function (e) {
                    $scope.orgAttachmentGridInstance = e.component;
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                allowColumnReordering: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width: 518,
                    visible: false
                },
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };

            window.downloadDocument = function (id) {
                console.log("download document enter...");
                orgHKService.attachmentDownload(id).success(function (data, status, headers) {
                    var octetStreamMime = 'application/octet-stream;charset=UTF-8';
                    //var contentType = headers('content-type') || octetStreamMime;
                    var blob = new Blob([data], {type: octetStreamMime});
                    var attach = _.find($scope.attachmentDatasource, {id: id});
                    FileSaver.saveAs(blob, attach.documentName);
                    // if (window.navigator.msSaveBlob) {
                    //     navigator.msSaveBlob(blob, attach.documentName);
                    // } else {
                    //     // Try using other saveBlob implementations, if available
                    //     var saveBlob = navigator.webkitSaveBlob || navigator.mozSaveBlob || navigator.saveBlob;
                    //     if (saveBlob === undefined) {
                    //         var urlCreator = window.URL || window.webkitURL || window.mozURL || window.msURL;
                    //         if (urlCreator) {
                    //             var a = document.createElement('a');
                    //             a.href = urlCreator.createObjectURL(blob);
                    //             a.target = '_blank';
                    //             a.download = attach.documentName;
                    //             document.body.appendChild(a);
                    //             a.click();
                    //         }
                    //     }
                    //     else {
                    //         saveBlob(blob, attach.documentName);
                    //     }
                    // }
                    console.log("download document finish...");
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            };

            window.deleteDocument = function (id) {
                console.log("delete document enter...");
                orgHKService.attachmentDelete(id).success(function (res) {
                    if (res && res.result) {
                        SweetAlert.success($translate.instant('deleteFileSuccess'));
                        $scope.attachmentDatasource = _.without($scope.attachmentDatasource, function (item) {
                            return item.id === id;
                        });
                        console.log("delete document finish...");
                    }
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });

            };

            (function initialize() {
                $log.debug('organizationManageController.ctor()...');
                $scope.title = $translate.instant('OrganizationManageTitle');
                initParams();
                loadDatagrid();
                initOrg();
                $timeout(function () {
                    getOrgList();
                }, 200);
                $scope.location = $scope.$root.isFront;
                $timeout(function () {
                    $scope.isLoadComplete = true;
                    if ($scope.location) {
                        $scope.showHeader = false;
                    }
                    else {
                        $scope.showHeader = true;
                    }
                }, 500);
            })();
        }
    ]);
